var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BidiHandler_id, _BidiHandler_ws, _BidiHandler_isConnected;
import { EventEmitter } from 'node:events';
import WebSocket from 'ws';
import logger from '@wdio/logger';
const log = logger('webdriver:BidiHandler');
const RESPONSE_TIMEOUT = 1000 * 60;
export class BidiHandler extends EventEmitter {
    constructor(_webSocketUrl) {
        super();
        this._webSocketUrl = _webSocketUrl;
        _BidiHandler_id.set(this, 0);
        _BidiHandler_ws.set(this, void 0);
        _BidiHandler_isConnected.set(this, false);
        log.info(`Connect to webSocketUrl ${this._webSocketUrl}`);
        __classPrivateFieldSet(this, _BidiHandler_ws, new WebSocket(this._webSocketUrl), "f");
    }
    connect() {
        return new Promise((resolve) => __classPrivateFieldGet(this, _BidiHandler_ws, "f").on('open', () => {
            __classPrivateFieldSet(this, _BidiHandler_isConnected, true, "f");
            resolve();
        }));
    }
    get socket() {
        return __classPrivateFieldGet(this, _BidiHandler_ws, "f");
    }
    get isConnected() {
        return __classPrivateFieldGet(this, _BidiHandler_isConnected, "f");
    }
    send(params) {
        var _a;
        if (!__classPrivateFieldGet(this, _BidiHandler_isConnected, "f")) {
            throw new Error('No connection to WebDriver Bidi was established');
        }
        const id = __classPrivateFieldSet(this, _BidiHandler_id, (_a = __classPrivateFieldGet(this, _BidiHandler_id, "f"), ++_a), "f");
        __classPrivateFieldGet(this, _BidiHandler_ws, "f").send(JSON.stringify({ id, ...params }));
        return new Promise((resolve, reject) => {
            const t = setTimeout(() => {
                reject(new Error(`Request with id ${id} timed out`));
                h.off('message', listener);
            }, RESPONSE_TIMEOUT);
            const listener = (data) => {
                try {
                    const payload = JSON.parse(data.toString());
                    if (payload.id === id) {
                        clearTimeout(t);
                        h.off('message', listener);
                        resolve(payload);
                    }
                }
                catch (err) {
                    log.error(`Failed parse message: ${err.message}`);
                }
            };
            const h = __classPrivateFieldGet(this, _BidiHandler_ws, "f").on('message', listener);
        });
    }
    sendAsync(params) {
        var _a;
        if (!__classPrivateFieldGet(this, _BidiHandler_isConnected, "f")) {
            throw new Error('No connection to WebDriver Bidi was established');
        }
        const id = __classPrivateFieldSet(this, _BidiHandler_id, (_a = __classPrivateFieldGet(this, _BidiHandler_id, "f"), ++_a), "f");
        __classPrivateFieldGet(this, _BidiHandler_ws, "f").send(JSON.stringify({ id, ...params }));
    }
}
_BidiHandler_id = new WeakMap(), _BidiHandler_ws = new WeakMap(), _BidiHandler_isConnected = new WeakMap();
